/*
 * Copyright  2005-7, Mark A. Rakes  All rights reserved.
 * ----------------------------------------------------------------------------------------------
 * Creative Commons Licence
 * ----------------------------------------------------------------------------------------------
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike License.
 * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-sa/2.0/
 * or send a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
 */
var tmr = null;
var editable = false;
var bkside = false;
var playTimer = null;
var isPlaying = false;
var resumePlaying = false;
var defSize = "36px";
var szArray = ["9px", "10px", "11px", "12px", "13px", "14px", "16px", 
			"18px", "24px", "36px", "48px", "72px", "96px", "128px"];
			var curSize = defSize;
var curSizeIdx = 9;

var defFont = "MarkerFelt-Thin";
var fontArray  = ["Baskerville", "Futura", "Gill Sans", "Helvetica Neue", 
			"Lucida Grande", "MarkerFelt-thin", "Optima"];
var curFont = defFont;

var timerArrayBound = 10;
var defTimeIdx = 2;
var curTimeIdx = defTimeIdx;

//howdy, DB!
var defData = "When all you have is a hammer, everything looks like a nail.";

var oldContent;
var oldControl;

// functions for dynamic html generation, etc.

function getAllowedFonts()
{
	if (window.widget) {
		if (window.FontSeePlugin) {
		 	FontSeePlugin.setupFontArray();
			fontArray = FontSeePlugin.fontArray();
			if (!fontArray) {
				FontSeePlugin.logMessage("fontArray returned empty!");
			}
		}
	} 
}

function changeFontLabel()
{
	var fl = document.getElementById('font-label');
	var fp = document.getElementById('font-popup');

	fl.innerText = fp.options[fp.selectedIndex].value;
}

function fontPullDown ()
{
	document.write("<select id='font-popup' class='popup' onchange='fontchanged(this);'>");
	for (var i = 0; i < fontArray.length; i++) {
		if (fontArray[i] != undefined)
			document.write("<option value='" + fontArray[i] + "'>" + fontArray[i] + "</option>");
	}
	document.write("</select>");
}

function timerPullDown ()
{
	document.write("<select id='timeUnit' class='popup' onchange='timerChanged(this);'>");
	for (var i = 0; i < timerArrayBound; i++) {
		document.write("<option value='" + i  + "'>" + (i + 1) + " sec. </option>");
	}
	document.write("</select>");
}

function setupData () 
{
	var size = defSize, data = defData, font = defFont;
	var td = document.getElementById("textdata");
    var timerElem = document.getElementById("timeUnit");
    var fontElem = document.getElementById("font-popup");
     
 	//FontSeePlugin.logMessage("setupData called");
    document.getElementById('timerlabel').innerText = getLocalizedString('Play Timer Interval:');
	if (window.widget) { //check for existing pref
		var sizePref = widget.preferenceForKey(createkey("size"));
		var dataPref = widget.preferenceForKey(createkey("data"));
		var fontPref = widget.preferenceForKey(createkey("font"));
	    var timerPref = widget.preferenceForKey(createkey("timerval"));
	
		if (sizePref != null)
			size = sizePref;
		if (dataPref != null)
			data = dataPref;
		if (fontPref != null)
			font = fontPref;
		if (timerPref != null)
			curTimeIdx = timerPref;
	}
	td.style.fontSize = size;
	td.style.fontFamily = font;
	td.innerHTML = data;
	curSize = size;
	curFont = font;
    
    timerElem.selectedIndex = curTimeIdx; 
	
	for (var i = 0; i < fontElem.options.length; i++) {
		if (fontElem.options[i].value == font) {
			fontElem.selectedIndex = i;
			break;
		}
	}
	changeFontLabel();
}

// button handling, preferences, etc.
function fontChange (fwd) 
{
	var fp = document.getElementById('font-popup');
	var td = document.getElementById("textdata");
	var lastFont = fontArray.length - 1;

	if (fwd == true) {
		if (fp.selectedIndex == lastFont)
			fp.selectedIndex = 0;
		else
			fp.selectedIndex++;
	} else {
		if (fp.selectedIndex == 0)
			fp.selectedIndex = lastFont;
		else
			fp.selectedIndex--;
	}
	fontchanged(fp);
}


function playFonts (stop) 
{
	if ((stop == true) || (playTimer != null)) {
		isPlaying = false;
		clearInterval(playTimer);
		playTimer = null;
	} else {	
		isPlaying = true;
		playTimer = setInterval('fontChange(true);', ((curTimeIdx + 1) * 1000));
	}
}

// functions for button handling
function mouseUp (event, id)
{
	var ft = document.getElementById("front");
	var bk = document.getElementById("behind");
	var sm = document.getElementById("small");
	var bg = document.getElementById("big");

	switch (id) {
		case "small":
			if (curSizeIdx == 0) {
				sm.src = "Images/nothing.png";
			} else {
				sm.src = "Images/"+id+".png";
				bg.src = "Images/big.png";
			}
			break;
		case "big":
			if (curSizeIdx == szArray.length - 1) {
				bg.src = "Images/nothing.png";
			} else {
				sm.src = "Images/small.png";
				bg.src = "Images/"+id+".png";
			}
			break;
		case "play":
			event.target.src = (isPlaying == true)?"Images/pause.png":"Images/play.png";
			break;
		default:
			event.target.src = "Images/"+id+".png";
			break;
	}
}

function doneUp()
{
	var ft = document.getElementById("front");
	var bk = document.getElementById("behind");

	if (window.widget)
		widget.prepareForTransition("ToFront");
	ft.style.display = "block";
	bk.style.display = "none";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	bkside = false;
	mouseexit(event);
	exitflip(event);

}

function mouseDown(event, id)
{

	switch (id) {
		case "fwd":
			event.target.src = "Images/d"+id+".png";
			fontChange(true);
			break;
		case "play":
			event.target.src = (isPlaying == true)?"Images/dpause.png":"Images/dplay.png";
			playFonts();
			break;
		case "bk":
			event.target.src = "Images/d"+id+".png";
			fontChange(false);
			break;
		case "small":
			if (curSizeIdx == 0)
				event.target.src = "Images/dnothing.png";
			else	
				event.target.src = "Images/d"+id+".png";
			sizebump(event, id, false);
			break;
		case "big":
			if (curSizeIdx == szArray.length - 1)
				event.target.src = "Images/dnothing.png";
			else
				event.target.src = "Images/d"+id+".png";
			sizebump(event, id, true);
			break;
	}
	event.stopPropagation();
	event.preventDefault();
}

// functions for saving preferences on change
function fontchanged (elem)
{	
	var td = document.getElementById("textdata");
	var font = elem.options[elem.selectedIndex].value;
	
	//td.style.display = "none";
	td.style.opacity = 0;
	td.style.fontFamily = font;
	
	if (window.widget)
		widget.setPreferenceForKey(font, createkey("font"));
	calculateAndShowThumb(td);
	changeFontLabel();
	td.style.opacity = 1;
	//td.style.display = "block";
}

function sizebump(event, id, up)
{	
	var td = document.getElementById("textdata");
	curSizeIdx += (up)?1:-1;
	if (curSizeIdx >= szArray.length -1)
		curSizeIdx = szArray.length - 1;
	else if (curSizeIdx <= 0)
		curSizeIdx = 0;
		
	td.style.fontSize = szArray[curSizeIdx];
	if (window.widget)
		widget.setPreferenceForKey(szArray[curSizeIdx], createkey("size"));
	calculateAndShowThumb(td);
}

function timerChanged(elem)
{	
    curTimeIdx = elem.selectedIndex;
	if (window.widget)
		widget.setPreferenceForKey(elem.selectedIndex, createkey("timerval"));
}


// ###################################################################
// more generic dashboard functions
// ###################################################################
function getLocalizedString (key)
{
	try {
		var ret = localizedStrings[key];
		if (ret == undefined)
			ret = key;
		return ret;
	} catch (ex) {}

	return key;
}

function makeEditable ()
{
	var td = document.getElementById("textdata");
	if (!editable) {
		td.contentEditable = true;
		editable = true;
	}
}

function focus ()
{	
	var td = document.getElementById("textdata");
    	makeEditable();
	td.style["color"] = 'rgba(0,0,0,0.8)';
}

function blur ()
{
	var td = document.getElementById("textdata");
	if (editable) {
		td.contentEditable = false;
		editable = false;
	}
	td.style["color"] = 'rgba(0,0,0,0.4)';
}

function onhide ()
{
	blur();
	//stop the play timer if it exists, and resume in onshow
	//don't worry about updating play button, as it won't be seen
	if (isPlaying == true) {
		resumePlaying =  true;
		playFonts(true);
	}
	clearTimer();
}

function onshow ()
{
	//focus();
	if (resumePlaying == true) {
		//since we didn't touch the play button at hide, it's still ok.
		playFonts();
		resumePlaying = false;
	}
}

function onremove ()
{
	// remove my instance preferences when remove from dashboard
	widget.setPreferenceForKey(null, createkey("data"));
	widget.setPreferenceForKey(null, createkey("font"));
	widget.setPreferenceForKey(null, createkey("size"));
	widget.setPreferenceForKey(null, createkey("timerval"));
}

window.onfocus = focus;
window.onblur = blur;

if (window.widget)
{
	widget.onhide = onhide;
	widget.onremove = onremove;
	widget.onshow = onshow;
}

function showbackside(event)
{
	var ft = document.getElementById("front");
	var bk = document.getElementById("behind");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	ft.style.display = "none";
	bk.style.display = "block";
	
	if (window.widget)		
		setTimeout('widget.performTransition();', 0);
	bkside = true;
}

function editclick (event)
{
	//stop the play timer, update the play button
	playFonts(true);
	document.getElementById("play").src = "Images/play.png";
	makeEditable();
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:0.5, now:0.0, from:0.0, element:null, tmr:null};

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();

	T = limit_3(time-animation.starttime, 0, animation.duration);	
	if (T >= animation.duration) {
		clearInterval (animation.tmr);
		animation.tmr = null;
		animation.now = animation.to;
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	animation.element.style.opacity = animation.now;
}

// toggle the flip icon
function flipit ()
{
		if (animation.tmr != null) {
			clearInterval (animation.tmr);
			animation.tmr  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.tmr = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		if (!flipShown)
		      animation.to = 0.5;
        animate();
        flipShown = !flipShown;
}
 
function mousemove (event)
{
	if (!flipShown)
	    flipit(); // fade in the flip widget
}

function mouseexit (event)
{
	if (flipShown)
		flipit(); // fade out the flip widget
}

function enterflip(event) {
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
	document.getElementById('fliprollie').style.display = 'none';
}

function createkey(key)
{
	return widget.identifier + "-" + key;
}

function displayText ()
{
	widget.setPreferenceForKey(document.getElementById("textdata").innerHTML, createkey("data"));
}

function mutationEvent (event)
{
	if (tmr != null)
		clearTimeout (tmr);
	tmr = setTimeout('displayText();', 5000);
}

function loaded ()
{
	var msb = document.getElementById("myScrollBar");
	var mstr = document.getElementById("myScrollTrack");
	var msth = document.getElementById("myScrollThumb");
	var td = document.getElementById('textdata');
	
	//FontSeePlugin.logMessage("load called");
	if (window.widget) {

		td.addEventListener("DOMCharacterDataModified", mutationEvent, false);
		td.addEventListener("DOMNodeInserted", mutationEvent, false);
	}
	scrollerInit(msb, mstr, msth);
	calculateAndShowThumb(td);
}


// handle command-'a'
function selectall ()
{
	var td = document.getElementById("textdata");
	window.getSelection().setBaseAndExtent(td.firstChild, 0, td.lastChild, td.lastChild.length);
}

function dopaste (event) 
{
	var fp = document.getElementById('font-popup');
	var pastedText = 0;
	var font, p;
	
	selectall();
	pastedText = event.clipboardData.getData('text/plain');
	if (pastedText) {
		var td = document.getElementById('textdata');
		event.stopPropagation();
		event.preventDefault();
		font = td.style.fontFamily;	
		td.innerHTML = pastedText;
		fontchanged(fp);
		displayText();
		calculateAndShowThumb(td);
	}
}

function keydown (event)
{
    //look for command-'a'
	var td = document.getElementById("textdata");
	//FontSeePlugin.logMessage("keydown called");
	if (event.metaKey && String.fromCharCode(event.charCode) == 'a') {
		selectall();
		event.stopPropagation();
		event.preventDefault();
	}

	calculateAndShowThumb(td);
}

document.addEventListener("keydown", keydown, true);

